import java.io.*;
import java.util.*;

public class C {
	static int timer, sx, sy;

	public void solve() throws IOException {
		PriorityQueue<Call> calls = new PriorityQueue<Call>();
		ArrayList<User> users = new ArrayList<User>();

		int n = nextInt();
		int m = nextInt();
		boolean done[] = new boolean[n];
		int res[] = new int[n];

		for (int i = 0; i < n; i++) {
			int t = nextInt();
			int a = nextInt() - 1;
			users.add(new User(t, a, i));
			calls.add(new Call(t, a, i));
		}

		while (!calls.isEmpty()) {
			timer = Math.max(timer, calls.peek().t);
			Call cur = calls.poll();
			if (done[cur.id])
				continue;

			timer += cur.fl;
			sy = cur.fl;
			sx = 0;

			for (User z : users) {
				z.update(sx, sy);
			}
			Collections.sort(users);
			int l = 0;
			int r = users.size();
			while (r - l > 1) {
				int mid = (r + l) / 2;
				if (coordOK(users.get(mid))) {
					l = mid;
				} else {
					r = mid;
				}
			}
			// users.s
			// SortedSet<User> deliver = users.headSet(new User(sx, 0, Integer.MAX_VALUE),
			// true);

			timer += cur.fl;
			for (int i = 0; i < r; i++) {
				res[users.get(i).id] = timer;
				done[users.get(i).id] = true;
			}
			for (int i = 0; i < r; i++) {
				users.remove(0);
			}
		}

		for (int x : res) {
			out.println(x);
		}
	}

	class Call implements Comparable<Call> {
		int t, fl, id;

		public Call(int t, int fl, int id) {
			super();
			this.t = t;
			this.fl = fl;
			this.id = id;
		}

		@Override
		public int compareTo(Call x) {
			if (t < x.t)
				return -1;
			if (t > x.t)
				return 1;
			if (id < x.id)
				return -1;
			if (id > x.id)
				return 1;
			return 0;
		}

		@Override
		public String toString() {
			return "Call [t=" + t + ", fl=" + fl + ", id=" + id + "]";
		}
	}

	class User implements Comparable<User> {
		int x, y, actx, id;

		public User(int x, int y, int id) {
			super();
			this.x = x;
			this.y = y;
			this.id = id;
		}

		public void update(int sx, int sy) {
			this.actx = this.x - timer;
		}

		// @Override
		public int compareTo(User z) {
			// this.actx = this.x - timer;
			// z.actx = z.x - timer;
			// this.polar = Math.atan2(-this.y + sy, -this.actx + sx);
			// z.polar = Math.atan2(-z.y + sy, -z.actx + sx);

			if (coordOK(this) && !coordOK(z))
				return -1;
			if (!coordOK(this) && coordOK(z))
				return 1;
			if (x < z.x)
				return -1;
			if (x > z.x)
				return 1;
			if (y < z.y)
				return -1;
			if (y > z.y)
				return 1;
			if (id < z.id)
				return -1;
			if (id > z.id)
				return 1;
			return 0;
		}

		@Override
		public String toString() {
			return "User [x=" + x + ", y=" + y + ", actx=" + actx + ", id=" + id + "]";
		}
	}

	public boolean coordOK(User z) {
		int x = z.actx - sx;
		int y = z.y - sy;
		if (x <= 0 && y <= 0) {
			return true;
		}
		if (x > 0 && y < 0 && -y >= x) {
			return true;
		}
		return false;
	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new C().run();
	}

}
