import java.io.*;
import java.util.*;

public class D {
	public void solve() throws IOException {
		int n = nextInt();
		int m = nextInt();
		int t = nextInt();
		
		int cnt[] = new int[26];
		int w[] = new int[26];
		Arrays.fill(w, Integer.MAX_VALUE);
		
		for (int i = 1; i < n; i++) {
			int f = nextInt();
			char c = nextToken().charAt(0);
			cnt[c-'a']++;
		}
		
		for (int i = 0; i < m; i++) {
			int v = nextInt();
			char c = nextToken().charAt(0);
			w[c-'a'] = Math.min(w[c-'a'], v);
		}
		
		int res = 0;
		for (int i = 0; i < 26; i++) {
			if (cnt[i] == 0)
				continue;
			if (w[i] == Integer.MAX_VALUE) {
				out.println(-1);
				return;
			}
			res += cnt[i]*w[i];
		}
		
		out.println(res);
	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new D().run();
	}

}
