import java.io.*;
import java.util.*;

public class CC {
	static int n, m;
	static ArrayList<Integer> a[], dist;

	public void solve() throws IOException {
		n = nextInt();
		m = nextInt();
		a = new ArrayList[n];
		for (int i = 0; i < n; i++) {
			a[i] = new ArrayList<Integer>();
		}

		for (int i = 1; i < n; i++) {
			int t = nextInt() - 1;
			a[i].add(t);
			a[t].add(i);
		}

		dist = new ArrayList<Integer>();
		DFS(0, 1, -1);
		Collections.sort(dist, Collections.reverseOrder());
		int max1 = dist.get(0);
		int max2 = dist.get(1);

		out.println(1L * max1 * m + max2 + max1 * (m - 1) - 1);
	}

	public void DFS(int x, int d, int p) {
		if (a[x].isEmpty() || a[x].size() == 1 && a[x].get(0) == p) {
			dist.add(d);
			return;
		}
		for (int z : a[x]) {
			if (z != p)
				DFS(z, d + 1, x);
		}
	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new CC().run();
	}

}
