import java.io.*;
import java.util.*;

public class CC {
	static int n, nlog, m, dist, tin[], tout[], dp[][], deep[], timer;
	static ArrayList<Integer> a[], leaf;
	static boolean vis[];

	public void solve() throws IOException {
		n = nextInt();
		m = nextInt();
		a = new ArrayList[n];
		for (int i = 0; i < n; i++) {
			a[i] = new ArrayList<Integer>();
		}
		vis = new boolean[n];
		for (int i = 1; i < n; i++) {
			int t = nextInt() - 1;
			a[i].add(t);
			a[t].add(i);
		}
		leaf = new ArrayList<Integer>();
		tin = new int[n];
		tout = new int[n];
		deep = new int[n];
		nlog = (int) (Math.log(n) / Math.log(2)) + 1;
		dp = new int[n][nlog];

		DFS(0, 1, 0);
		int revert = 0;

		for (int i = 0; i < leaf.size(); i++) {
			for (int j = i + 1; j < leaf.size(); j++) {
				revert = Math.max(revert, dist(leaf.get(i), leaf.get(j)));
			}
		}

		out.println(revert + 2 * (m - 1) * dist);
	}

	public void DFS(int x, int d, int p) {
		vis[x] = true;
		tin[x] = ++timer;
		deep[x] = d;

		dp[x][0] = p;
		for (int i = 1; i < nlog; i++) {
			dp[x][i] = dp[dp[x][i - 1]][i - 1];
		}

		boolean hit = false;
		for (int z : a[x]) {
			if (!vis[z]) {
				DFS(z, d + 1, x);
				hit = true;
			}
		}
		if (!hit) {
			dist = Math.max(dist, d);
			leaf.add(x);
		}
		tout[x] = ++timer;
	}

	public int dist(int a, int b) {
		int c = lca(a, b);
		return deep[a] - deep[c] + deep[b] - deep[c] + 1;
	}

	public boolean isPar(int a, int b) {
		return (tin[a] < tin[b] && tout[b] < tout[a]);
	}

	public int lca(int a, int b) {
		if (isPar(a, b))
			return a;
		if (isPar(b, a))
			return b;
		for (int i = nlog - 1; i >= 0; i--) {
			if (!isPar(dp[a][i], b)) {
				a = dp[a][i];
			}
		}
		return dp[a][0];
	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new CC().run();
	}

}
